<?php

//--BY--Andrew-Portolese------------------------

//Do not edit anything below this line!!
//-----------------------------------------------------------------------------------------------------------

/*
//Commonly used features

//Page include code
	<?php include("auto_menu_classes.php"); ?>

//Display first level in hierarchy
	<?php 	$auto_menu->display_level_1();		?>

//Display Second level only
	<?php 	$auto_menu->display_level_2(script_name(),1);		?>

//Display Breadcrumb
	<?php  $auto_menu->display_bread_crumb(script_name()); ?>
	
//Display Page Caption
	<?php  $auto_menu->display_caption(script_name()) ?>


*/

	function script_name()
	{//finds the script name
		if ( strrchr($_SERVER['PHP_SELF'], '/') )
		{
			
			return substr(strrchr($_SERVER['PHP_SELF'], '/'),1);
		} else {
			return $_SERVER['PHP_SELF'];
		}
	}
	

	
	function all_folder_names($url)
	{
		$string = explode("/", $_SERVER['PHP_SELF'], -1);
		foreach ($string as $index=>$value) 
		{
			$value = '/'.$value.'/';
			if ($value == $url)
			{
				return 1;
			}
		}
		return 0;		
	}
	
	function current_folder_name()
	{		
			$string = rstrstr($_SERVER['PHP_SELF'], '/');
			$string = strrchr($string, '/');
			$string = substr($string,0);
			$string = $string."/";
			return $string;
	}
	
	function rstrstr($haystack, $needle)
	{
		return substr(strrev(strstr(strrev($haystack), strrev($needle))), 0, -strlen($needle));
	} 
	
	function webtag($tagname, $inside)
	{
		if ($tagname != "")
		{			
			return '<'.$tagname.'>'.$inside.'</'.$tagname.'>';		
		}
		return $inside;
		
	}
	
	function formtag($tagname, $inside, $name)
	{
		if ($tagname != "")
		{
			
			return '<'.$tagname.' name="'.$name.'">'.$inside.'</'.$tagname.'>';		
		}
		return $inside;
		
	}


//START class menu -------------------------------------------------------------------------------------------
class menu
{
	public $auto_menu = array();
	public $title;
	public $title_display;	
	public $title_tag;
	public $type;
	public $selected;
	
	function create($c, $u, $next)
	{
		$this->auto_menu[] = new nav_link($c, $u, $next);
	}
	
//START display functions ------------------------------------------------------------------------------
	function display_all()
	{
		
		$this->display_title();
		
		echo $this->new_level_open();
		foreach ($this->auto_menu as $index=>$nav_link)//go through list of all nav_links
		{
			if (0 == strcmp($this->auto_menu[$index]->parent, ""))
			{
				echo $this->display($index,$this->display_children($this->auto_menu[$index]->url,2,99));
			}
		}
		echo $this->new_level_close();
		
		//reset display
		foreach ($this->auto_menu as $index=>$nav_link)
		{
			$this->auto_menu[$index]->displayed = 0;
		}
	}//end display_all
	
	function display_level_1()
	{
		$this->display_title();
		echo $this->new_level_open();
		foreach ($this->auto_menu as $index=>$nav_link)
		{
			if ($this->auto_menu[$index]->parent == "")
			{
				echo $this->display($index,"");
			}
		}
		echo $this->new_level_close();
		//reset display
		foreach ($this->auto_menu as $index=>$nav_link)
		{
			$this->auto_menu[$index]->displayed = 0;
		}
		
	}//end display_level_1
	
	function display_level_2($url,$levelsin)
	{
		$output = "";
		$this->display_title();
		foreach ($this->auto_menu as $index=>$nav_link)
		{
			if ( strcmp( $this->auto_menu[$index]->url , $url) == 0 )
			{					
				$output = $output.$this->display_children($this->auto_menu[$index]->url,1,$levelsin);
			}
		}
		echo $output;
		if ($output == "")
		{
			echo $this->display_level_2_only($url,$levelsin);
		} 
		
	}//end display_level_2
	
	function display_level_2_only($url,$levelsin)
	{
		//once parent found, mark with a flag to stop the for each loop
		$output = "";
		$found = 0;
		if ($url != "")
		{
			foreach ($this->auto_menu as $index=>$nav_link)//go through entire menu
			{	
				if (0 == strcmp($this->auto_menu[$index]->url, $url))//where the url matchs 
				{
					if ( ($this->auto_menu[$index]->parent != "") && !$found ) //don't display level 1
					{	
							$found = 1;
						 	$output = $output.$this->display_children($this->auto_menu[$index]->parent, 1,$levelsin);
					}
				}
			}			
		}
		
		return $output;
	}//end display_level_2_only
		
	
	
//END display functions ------------------------------------------------------------------------------


	function display_level_2_exist($url,$levelsin)
	{
		$output = "";
		$this->display_title();
		foreach ($this->auto_menu as $index=>$nav_link)
		{
			if ( strcmp( $this->auto_menu[$index]->url , $url) == 0 )
			{					
				$output = $output.$this->display_children($this->auto_menu[$index]->url,1,$levelsin);
			}
		}
		$output = $output.$this->display_level_2_only($url,$levelsin);
		if ($output == "")
		{
			echo "Single Big Div";
		} else {
			echo "Left Sidebar and main content div";	
		}
		
	}//end display_level_2




//START inner display formatting functions -------------------------------------------------------------------------	
	
	function display_children($nav_link_parent,$level,$levelsin)
	{
		$output = "";
		foreach ($this->auto_menu as $index=>$nav_link)//go through entire menu
		{	
			if ($level <= $levelsin)//check levels in 
			{
				if ($this->auto_menu[$index]->displayed == 0) //if it hasn't been displayed yet then 
				{
					if (0 == strcmp($this->auto_menu[$index]->parent, $nav_link_parent))//see if this is the right section by comparing parents
					{
						
						$output = $output.$this->display($index, $this->display_children($this->auto_menu[$index]->url, ($level+1),$levelsin));
						
						
					}				
				}
			}
			
			
		}	
		if ($output != "")
		{
			return $this->new_level_open().$output.$this->new_level_close();
		} else {
			return $output;
		}
		//return string here, add to string within for loop
		
	}//end display_children
	
	function new_level_open()
	{
		return "<ul>\n";
	}
	
	function new_level_close()
	{
		return "</ul>\n";
	}
	
	function display($index,$inside)
	{				
		if ($this->type == "list")
		{
			return $this->display_list($index,$inside);
		} else if ($this->type == "text")
		{
			//then display text
			//$this->display_list($index);
		} else {
			
		}
		
	}//end display

	
	function display_list($index,$inside)
	{
		//if url is a folder, then see if its equal to this folder
		if (  ($this->auto_menu[$index]->url == script_name()) || ( all_folder_names($this->auto_menu[$index]->url)  )  )
		
		{  //$this->auto_menu[$index]->url == current_folder_name()    currrent folder only
			$output = "";		
			$output = $output."<a href=\"";
			$output = $output.$this->auto_menu[$index]->url;			
			$output = $output."\" class=\"";
			$output = $output.$this->selected;
			$output = $output."\" >";		
			$output = $output.$this->auto_menu[$index]->caption;		
			$output = $output."</a>";			
			$output = webtag("li", $output."\n".$inside);
			$output = $output."\n";
			return $output;
		} else {
			$output = "";		
			$output = $output."<a href=\"";
			$output = $output.$this->auto_menu[$index]->url;			
			$output = $output."\" >";		
			$output = $output.$this->auto_menu[$index]->caption;		
			$output = $output."</a>";
			$output = webtag("li", $output."\n".$inside);
			$output = $output."\n";
			return $output;
		}
			
	}//end display_list

	
	function display_title()
	{
		if ($this->title_display == true) {
			echo webtag($this->title_tag, $this->title);	
			echo "\n";
		}	
	}
	
	function display_caption($url)
	{
		if ($url != "")
		{
			foreach ($this->auto_menu as $index=>$nav_link)
			{	
				if (0 == strcmp($this->auto_menu[$index]->url, $url))
				{
					
					echo $this->auto_menu[$index]->caption;
				}
			}
		}
		
	}
	
//END inner display formatting functions -------------------------------------------------------------------------	
	
//START breadcrumb -----------------------------------------------------------------------------------------------	
	function display_bread_crumb($index)
	{
		echo $this->bread_crumb($index);
	}
	

	
	function bread_crumb($url)
	{
		if ($url != "")
		{
			foreach ($this->auto_menu as $index=>$nav_link)
			{	
				if (0 == strcmp($this->auto_menu[$index]->url, $url))
				{
					
					return $this->bread_crumb($this->auto_menu[$index]->parent).' - '.$this->auto_menu[$index]->caption;
				}
			}
		}		
	}
	
	
//END breadcrumb -------------------------------------------------------------------------------------------------

}//end class menu

class nav_link
{
	public $caption;
	public $url;
	public $parent = null;
	public $displayed = 0;
	
	function __construct($c, $u, $next)
	{
		$this->caption = $c;
		$this->url = $u;
		$this->parent = $next;		
	}

}		
	